$!-----------------------------------------------------------------
$!  Procedure: Run ORTEP
$!
$!  Programmer: Rong-Sheng Zhou
$!
$!		ALFRED UNIVERSITY, MAY-1987
$!
$!  This command procedure supports optional P1. ORTEP.HLP contains
$!  the information on P1 input. ORTEP uses an intermediate scratch
$!  file GRAF_IT.P1 to pass P1 into the *.EXEs.
$!-----------------------------------------------------------------
$!
$ V_FLAG = 'F$VERIFY(0)'
$ SET NOVERIFY
$!
$!  Assignment GRAF$IT is literally required by some of subroutines
$!  in HPLIB.OLB. Therefore please do not change it unless you make
$!  the same change in HPLIB.
$!
$ ASSIGN UTIL:[UTILITY.GRAFIT]  GRAF$IT:
$ ASSIGN POWD:[POWDER.ORTEP]    OR$TEP:
$!
$ O_MODE = 0		!RUN OUTPUT MODE
$ D = "WRITE SYS$OUTPUT"
$!
$ ON     ERROR THEN GOTO RESET_STEP
$ ON CONTROL_Y THEN GOTO RESET_STEP
$!
$!  Parse P1...
$!
$ IF P1.EQS."" THEN GOTO RUN_STEP
$ IF P1.EQS."HELP" .OR. P1.EQS."?" THEN GOTO SHOW_HELP
$!
$!  Parse P1 for qualifiers...
$!
$ FILE = P1
$ LOOP_QUALIFIER:
$!
$ SIZE = F$LENGTH(FILE)
$ SLASH = F$LOCATE("/",FILE)
$ IF SLASH.EQ.SIZE THEN GOTO M_CHECK
$ C = F$EXTRACT(SLASH+1,2,FILE)
$ IF C.NES."M=".AND.C.NES."O=".AND.C.NES."P=" THEN GOTO ERROR_QUALIFIER
$ FILE = F$EXTRACT(SLASH+1,SIZE-SLASH,FILE)
$ IF FILE.NES."" THEN GOTO LOOP_QUALIFIER
$!
$!  Parse P1 for /M keywords...
$!
$ M_CHECK:
$!
$ SLASH = F$LOCATE("/M=",P1)
$ IF SLASH.EQ.SIZE THEN GOTO SAVE_P1
$ C = F$EXTRACT(SLASH+3,1,P1)
$ IF C.NES."H".AND.C.NES."P" THEN GOTO ERROR_PARAMETER
$ IF C.EQS."H" THEN O_MODE = 2
$!
$!  Store P1 in GRAF_IT.P1...
$!
$ SAVE_P1:
$!
$ IF F$LOCATE("/O=",P1).NE.SIZE THEN O_MODE = 2
$ IF O_MODE.EQ.0 THEN O_MODE = 1
$ ASSIGN GRAF_IT.P1 SYS$OUTPUT
$ WRITE SYS$OUTPUT P1
$ DEASSIGN SYS$OUTPUT
$ GOTO RUN_STEP
$!
$ ERROR_QUALIFIER:
$!
$ D "[7m_ERROR: invalid qualifier(s).[0m"
$ GOTO EXIT
$!
$ ERROR_PARAMETER:
$!
$ D "[7m_ERROR: invalid qualifier parameter.[0m"
$ GOTO EXIT
$!
$ RUN_STEP:
$!
$ IF O_MODE.NE.2 THEN SET TERM/VT100/NOWRAP/INSERT/NUMERIC/ESCAPE
$ IF O_MODE.EQ.0 THEN D "[7;5m_Setting up the terminal...[0m"
$!
$ DEASSIGN SYS$INPUT
$ RUN OR$TEP:ORTEP.EXE
$ GOTO EXIT
$!
$!  GRAFIT_TEK_1.EXE only performs terminal reset for a TEK-4100
$!  command series terminal since the others supported by
$!  ORTEP do not require any reset procedures after run abort.
$!
$ RESET_STEP:
$!
$ RUN GRAF$IT:GRAFIT_TEK_1.EXE
$ D "7[?6l[1;24r8[0m[0J"	!RESET ANSI ATTRIBUTES
$ GOTO EXIT
$!
$!  Display help on supported command procedures.
$!
$ SHOW_HELP:
$!
$ TYPE/PAGE OR$TEP:ORTEP.HLP
$!
$ EXIT:
$ DEASSIGN GRAF$IT:
$ DEASSIGN OR$TEP:
$ IF O_MODE.EQ.0 THEN GOTO VERIFY
$!
$!  We don't want GRAF_IT.P1 hanging around to screw up the next run. 
$!
$ FILE = F$SEARCH( "GRAF_IT.P1" )
$ IF FILE.NES."" THEN DELETE/NOLOG GRAF_IT.P1;*
$!
$ VERIFY:
$ IF V_FLAG THEN SET VERIFY
$ EXIT
